import { KeyMapper, EventName, Type, Listener } from "../types";
import { MarkedInputProps } from "../components/MarkedInput";
export declare class EventBus {
    #private;
    get events(): any;
    static withExternalEventsFrom(props: MarkedInputProps): () => EventBus;
    constructor(...initEvents: EventName[]);
    get<T extends keyof KeyMapper>(key: T): KeyMapper[T];
    set<T extends keyof KeyMapper>(key: T, value: KeyMapper[T]): void;
    send(event: Type, arg?: any): void;
    send(event: EventName, arg: any): void;
    listen(event: EventName | Type, listener: Listener): () => void;
}
export interface ListenerOptions {
    readonly preventDefault?: boolean;
}
//# sourceMappingURL=EventBus.d.ts.map