import React from "react";
import { ElementOptions, KeyedPieces, AnnotatedMark, Markup, Options, Piece, NodeData, Store, Mark } from "../types";
import { OptionProps } from "../components/Option";
import LinkedList from "./LinkedList";
export declare const assign: {
    <T extends {}, U>(target: T, source: U): T & U;
    <T_1 extends {}, U_1, V>(target: T_1, source1: U_1, source2: V): T_1 & U_1 & V;
    <T_2 extends {}, U_2, V_1, W>(target: T_2, source1: U_2, source2: V_1, source3: W): T_2 & U_2 & V_1 & W;
    (target: object, ...sources: any[]): any;
};
export declare const markupToRegex: (markup: Markup) => RegExp;
/**
 * Make annotation from the markup
 */
export declare function annotate(markup: Markup, label: string, value?: string): string;
/**
 * Transform the annotated text to the another text
 */
export declare function denote(value: string, callback: (mark: AnnotatedMark) => string, ...markups: Markup[]): string;
export declare const escapeRegex: (str: string) => string;
export declare function toString(values: Mark[], options: Options): string;
export declare const normalizeMark: (mark: AnnotatedMark, markup: Markup) => AnnotatedMark;
export declare const genHash: (str: string, seed?: number) => number;
export declare const genId: () => string;
export declare const isObject: (value: unknown) => value is object;
export declare const isAnnotated: (value: unknown) => value is AnnotatedMark;
export declare const isFunction: (value: unknown) => value is Function;
export declare const isEventName: (value: string | number) => value is `on${string}`;
export declare function extractOptions(options?: ElementOptions<any> | OptionProps[]): Options;
export declare const useStore: () => Store, StoreContext: React.Context<Store>;
export declare const useValue: () => LinkedList<NodeData>, ValueContext: React.Context<LinkedList<NodeData>>;
export declare function debounce(func: Function, wait: number, immediate?: boolean): () => void;
export declare function findSpanKey(span: string, pieces: KeyedPieces): number | undefined;
export declare function createNewSpan(span: string, annotation: string, index: number, source: string): string;
export declare function genKey(piece: Piece, cache?: Set<number>): number;
//# sourceMappingURL=index.d.ts.map